/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Clase base para el procesamiento del xml generado a partir de
la informacin de xrefsrc.
- ENGLISH -
Base class for xrefsrc xml processing.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING PROGRESS.Lang.AppError.
USING com.nomadesoft.lib.*.
USING com.nomadesoft.ABLaUML.repository.*.
USING com.nomadesoft.ABLaUML.ABLXMLWorker.

/**
Se encarga de crear todos los objetos y paquetes necesarios para luego poder procesar las relaciones
entre ellos.
**/
CLASS com.nomadesoft.ABLaUML.FUWorker INHERITS ABLXMLWorker:
  CONSTRUCTOR FUWorker(INPUT ipobUtils AS CLASS IUtils):
    SUPER(ipobUtils).
  END CONSTRUCTOR.

  /* mtodos que los hijos sobrescribirn para hacer el trabajo real, invocados desde la implementacin de IXMLWorker */
  METHOD PROTECTED VOID FunctionalUnitStart():
  END METHOD.
  METHOD PROTECTED VOID IncludeStart():
  END METHOD.
  METHOD PROTECTED VOID ProgramStart():
  END METHOD.
  METHOD PROTECTED VOID CallStart():
  END METHOD.
  METHOD PROTECTED VOID TableRefStart():
  END METHOD.
  METHOD PROTECTED VOID FieldRefStart():
  END METHOD.
  METHOD PROTECTED VOID UnknownStart():
    cobParser:doLog(STRING(THIS-OBJECT),'Comienzo elemento desconocido','WARNING').
  END METHOD.
  METHOD PROTECTED VOID FunctionalUnitEnd():
  END METHOD.
  METHOD PROTECTED VOID IncludeEnd():
  END METHOD.
  METHOD PROTECTED VOID ProgramEnd():
  END METHOD.
  METHOD PROTECTED VOID CallEnd():
  END METHOD.
  METHOD PROTECTED VOID TableRefEnd():
  END METHOD.
  METHOD PROTECTED VOID FieldRefEnd():
  END METHOD.
  METHOD PROTECTED VOID UnknownEnd():
    cobParser:doLog(STRING(THIS-OBJECT),'Fin elemento desconocido','WARNING').
  END METHOD.

  /* implementacin de IXMLWorker */
  METHOD PUBLIC OVERRIDE VOID ElementStart(INPUT ipobParser AS CLASS IXMLParser):
    SUPER:ElementStart(ipobParser).
    case cobParser:CurrentElement():
      when "fu" THEN
        FunctionalUnitStart().
      WHEN 'include' THEN
        IncludeStart().  
      WHEN 'program' THEN
        ProgramStart().
      WHEN 'call' THEN
        CallStart().
      WHEN 'tableref' THEN
        TableRefStart().
      WHEN 'fieldref' THEN
        FieldRefStart().
      OTHERWISE
          UnknownStart().
    END.
  END METHOD.
  METHOD PUBLIC OVERRIDE VOID ElementEnd(INPUT ipobParser AS CLASS IXMLParser):
    SUPER:ElementEnd(ipobParser).
    case cobParser:CurrentElement():
      when "fu" THEN
        FunctionalUnitEnd().
      WHEN 'include' THEN
        IncludeEnd().  
      WHEN 'program' THEN
        ProgramEnd().
      WHEN 'call' THEN
        CallEnd().
      WHEN 'tableref' THEN
        TableRefEnd().
      WHEN 'fieldref' THEN
        FieldRefEnd().
      OTHERWISE
          UnknownEnd().
    END.
    cobParser:doLog(STRING(THIS-OBJECT),SUBSTITUTE('Fin elemento &1',QUOTER(cobParser:CurrentElement())),'DEBUG').
  END METHOD.
END CLASS.
