ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING PROGRESS.Lang.AppError.
USING com.nomadesoft.lib.*.
USING com.nomadesoft.ABLaUML.repository.*.
USING com.nomadesoft.ABLaUML.FullDDWorker.

/**
Se encarga de completar la definicin de todos los objetos que integran el modelo de datos.
**/
CLASS com.nomadesoft.ABLaUML.FillDDWorker INHERITS FullDDWorker:
  CONSTRUCTOR FillDDWorker(INPUT ipobUtils AS CLASS IUtils):
    SUPER(ipobUtils).
  END CONSTRUCTOR.

  /* mtodos que los hijos sobrescribirn para hacer el trabajo real, invocados desde la implementacin de IXMLWorker */
  METHOD PROTECTED OVERRIDE VOID DatabaseStart():
    cinDBPackageId = cobUtils:FindPackage(
        input cobParser:AttributeValue('name'),
        input cinDataModelPackageID
        ). 
    IF cinDBPackageId EQ 0 THEN
      cinDBPackageID = ?.
    IF cinDBPackageID NE ? THEN
      cobParser:DoLog(STRING(THIS-OBJECT),SUBSTITUTE('Completando base de datos &1',cobParser:AttributeValue('name')),'NOTICE').
    ELSE
      cobParser:doLog(STRING(THIS-OBJECT),SUBSTITUTE('Base de datos &1 no existe',cobParser:AttributeValue('name')),'DEBUG').
  END METHOD.
  METHOD PROTECTED OVERRIDE VOID TableStart():
    IF cinDBPackageID EQ ? THEN
      RETURN.
    cinTableID = cobUtils:FindObject (
        input "Class",
        input "nsTable",
        input cobParser:AttributeValue('name'),
        cinDBPackageID
        ).
    if  cinTableID EQ 0 THEN
      cinTableID = ?.
    IF cinTableID EQ ? THEN DO:
      cobParser:DoLog(STRING(THIS-OBJECT),SUBSTITUTE('Tabla &1 no existe',cobParser:AttributeValue('name')),'DEBUG').
      RETURN.
    END.
    cobParser:DoLog(STRING(THIS-OBJECT),SUBSTITUTE('Completando tabla &1',cobParser:AttributeValue('name')),'NOTICE').
    cobUtils:AddObjectNotes(cinTableID,cobParser:AttributeValue('desc')).
    IF clgCreateTableTags THEN
      CreateObjectTags(cinTableID,cchTableTagsMap).
  END METHOD.
  METHOD PROTECTED OVERRIDE VOID FieldStart():
    IF cinDBPackageID EQ ? OR cinTableID EQ ? THEN
      RETURN.
    SUPER:FieldStart().
  END METHOD.
  METHOD PROTECTED OVERRIDE VOID IndexStart():
    IF cinDBPackageID EQ ? OR cinTableID EQ ? THEN
      RETURN.
    SUPER:IndexStart().
  END METHOD.
  METHOD PROTECTED OVERRIDE VOID StorageAreaStart():
    IF cinDBPackageID EQ ? OR cinTableID EQ ? THEN
      RETURN.
    SUPER:StorageAreaStart().
  END METHOD.
  METHOD PROTECTED OVERRIDE VOID SequenceStart():
    IF cinDBPackageID EQ ? THEN
      RETURN.
    SUPER:SequenceStart().
  END METHOD.
END CLASS.
