/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Genera el xml de las notas de los programas, segn la
informacin de XREF.
- ENGLISH -
Generates program notes xml, based on XREF data.
*****************/

ROUTINE-LEVEL ON ERROR UNDO, THROW.
USING com.nomadesoft.lib.XMLwriter.


CLASS com.nomadesoft.xml.Notaswriter INHERITS XMLwriter:

  DEFINE PUBLIC PROPERTY clgIncludeMapInfo AS LOGICAL NO-UNDO
    GET.
    SET.

  METHOD PROTECTED CHARACTER Normalizar(INPUT ipchNombre AS CHARACTER):
    IF ipchNombre EQ ? THEN
      RETURN ?.
    IF SUBSTRING(ipchNombre,1,1) EQ '.' THEN
      ENTRY(1,ipchNombre,'/') = ''.
    IF SUBSTRING(ipchNombre,1,1) EQ '/' THEN
      ipchNombre = SUBSTRING(ipchNombre,2).
    RETURN ipchNombre.
  END METHOD.

  METHOD PUBLIC OVERRIDE VOID writeXML(INPUT ipchDestino AS CHARACTER):
    DEFINE BUFFER ibfXRef FOR xrefsrc.xrfprg. 
    DEFINE VARIABLE mchContent AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE mchfu AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE mchcomp AS CHARACTER   NO-UNDO.
  
    StartXML('notas','generador,NomadeSoft XRef',ipchDestino).
    FOR EACH ibfXRef WHERE dscfil NE '' OR (clgIncludeMapInfo AND dscmap NE '') BREAK BY xrffil ON ERROR UNDO, THROW:
      IF FIRST-OF(xrffil) THEN
        mchContent = ''.
      IF clgIncludeMapInfo AND dscmap NE '' THEN
        mchContent = mchContent + '~n' + dscmap.
      IF dscfil NE '' THEN
        mchContent = mchContent + '~n' + CAPS(SUBSTRING(dscfil,1,1)) + SUBSTRING(dscfil,2).
      IF LAST-OF(xrffil) THEN DO:
        SUBSTRING(mchContent,1,1) = ''.
        mchcomp = Normalizar(paqprg).
        mchfu = ENTRY(1,mchcomp,'.').
        OutputTag('nota','path,' + Normalizar(xrffil) + ',fu,' + mchfu + ',component,' + mchcomp,mchContent).
      END.
    END.

    FINALLY:
      FinishXML().
    END FINALLY.
  END METHOD.
END CLASS.
